use maud::{html, Markup, PreEscaped};

/// Sbot error template builder.
///
/// Display a message to the operator when an sbot command returns an error.
pub fn build_template(error_msg: String) -> Markup {
    html! {
        (PreEscaped("<!-- SBOT ERROR -->"))
        div class="card center" {
            div class="capsule capsule-container border-danger center-text" {
                p class="card-text" style="font-size: var(--font-size-4);" {
                    "Sbot Error"
                }
                p class="card-text" { (error_msg) }
                p class="card-text" {
                    "Visit the "
                    strong {
                        a href="/settings/scuttlebutt" class="link" {
                            "Scuttlebutt settings menu"
                        }
                    }
                    " to start the Sbot and then try again."
                }
            }
        }
    }
}
